﻿using System;

namespace ConsoleApplication1
{
    class Person
    {
        public void Output(string name)
        {
            Output(name, 0, "Korea");
        }

        public void Output(string name, int age)
        {
            Output(name, age, "Korea");
        }

        public void Output(string name, int age, string address)
        {
            Console.WriteLine(string.Format("{0}: {1} in {2}", name, age, address));
        }

        public void Output2(string name, int age = 0, string address = "Korea", params int[] tests)
        {
            Console.WriteLine(string.Format("{0}: {1} in {2}", name, age, address));
        }


        public void Output3(string name, int age, string address = "Korea", params int[] tests)
        {
            Console.WriteLine(string.Format("{0}: {1} in {2}", name, age, address));
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Person p = new Person();

            p.Output("Anders");
            p.Output("Winnie", 36);
            p.Output("Tom", 28, "Tibet");

            p.Output2("Anders");
            p.Output2("Winnie", 36);
            p.Output2("Tom", 28, "Tibet");

            // p.Output2("Tom", "Tibet"); !에러 발생
            p.Output2("Tom", address: "Tibet");
            p.Output2(address: "Tibet", name: "Tom");
            p.Output2(age: 5, name: "Tom", address: "Tibet");
        }
    }
}
